org 58391

RUTINILLA

    di

    ld bc, ROOM
    ld a, (bc)
    inc a

    ld hl, MAP

    ld d, 0

    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    ld e, a                          ; DE = A * 32

    add hl, de                       ; HL = MAP + Num Hab * 32

    ld a, (bc)
    inc a


    ld d, 0

    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    ld e, a                          ; DE = A * 8


    add hl, de                       ; HL = MAP + Num Hab * 32 + Num Hab * 8

    dec hl                           ; Ahora tenemos HL apuntando al LTIMO supertile de la habitacin

    ld bc, #0508

    BUCLE1:

    push hl
    push bc

    ld a, (hl)
    call PRINT_SUPERTILE

    pop bc
    pop hl

    dec hl
    dec c

    jr nz, BUCLE1

    ld c,8
    djnz BUCLE1




EXIT:
ei
ret



; UDG_LOCATE: Devuelve en IX la direccin del UDG solicitado en A

UDG_LOCATE:
    ld ix, UDGS

    and a
    ret z

    dec a

    ld d, 0

    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    ld e, a                          ; DE = A * 8


    add ix, de

    ret

PRINT_SUPERTILE:
;    and a
;    ret z

    ld iy, SUPERTILES

    ld d, 0

    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    sla a
    rl d
    ld e, a                          ; DE = A *32

    add iy, de       ; Tenemos IY apuntando al supertile que queremos

    dec b
    dec c

    sla b
    sla b
    inc b
    sla c
    sla c

    push bc

    ld de, #0404

    PST_Bucle:

    call DF_LOCATE

    ld a, (iy)   ; A = Nmero del  UDG
    exx
    call UDG_LOCATE
    exx

    ld a, (ix)
    ld (hl), a
    inc h
    ld a, (ix + 1)
    ld (hl), a
    inc h
    ld a, (ix + 2)
    ld (hl), a
    inc h
    ld a, (ix + 3)
    ld (hl), a
    inc h
    ld a, (ix + 4)
    ld (hl), a
    inc h
    ld a, (ix + 5)
    ld (hl), a
    inc h
    ld a, (ix + 6)
    ld (hl), a
    inc h
    ld a, (ix + 7)
    ld (hl), a

    inc iy

    inc b

    dec d
    jr nz, PST_Bucle


    ld a, b
    sub 4
    ld b, a
    inc c

    ld d,4
    dec e
    jr nz, PST_Bucle

    pop bc

    ld de, 32
   
    call ATT_LOCATE

    ld b, 4
    ld c, 4

    PST_BucleATTR:

    ld a, (IY)
    ld (hl), a

    inc iy
    add hl, de

    djnz PST_BucleATTR

    and a
    sbc hl, de
    sbc hl, de
    sbc hl, de
    sbc hl, de
    inc hl

    ld b, 4
    dec c
    jr nz, PST_BucleATTR

    ret

; ATT_LOCATE: Devuelve en HL la direccin de atributos
; Entrada: BC Coordenadas: B = Lnea C = Columna
; Salida: HL Direccin de atributos
; Se conservan DE y BC

ATT_LOCATE:
    ld a, b
    sra a
    sra a
    sra a
    add a, #58
    ld h, a
    ld a, b
    and 7
    rrca
    rrca
    rrca
    add a, c
    ld l, a
    ret


; DF_LOCATE: Devuelve en HL la direccin del archivo de pantalla
; Entrada: BC Coordenadas: B = Lnea C = Columna
; Salida: HL Direccin del archivo de pantalla
; Se conservan DE y BC

DF_LOCATE:
    ld a, b
    and #f8
    add a, #40
    ld h, a
    ld a, b
    and 7
    rrca
    rrca
    rrca
    add a, c
    ld l, a
    ret

ROOM:

    db 0

SUPERTILES:

        defb 105,105,105,105,105,105,105,105,105,105,105,105,105,105,105,105
        defb 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7                    ; attrs

        defb 127,130,130,133,128,131,131,134,128,131,131,134,129,132,132,135
        defb 67,67,67,3,67,65,65,1,67,65,65,1,3,1,1,1           ; attrs

        defb 127,130,130,133,128,131,131,134,128,131,131,134,129,132,132,135
        defb 15,15,15,5,15,5,5,65,15,5,5,65,5,65,65,1           ; attrs

        defb 127,130,130,133,128,131,131,134,128,131,131,134,129,132,132,135
        defb 71,70,70,70,70,6,6,6,70,6,6,6,70,6,6,68            ; attrs

        defb 127,130,130,133,128,131,131,134,128,131,131,134,129,132,132,135
        defb 70,6,6,68,6,68,68,4,6,68,68,4,68,4,4,5             ; attrs

        defb 127,130,130,133,128,131,131,134,128,131,131,134,129,132,132,135
        defb 66,66,66,2,66,2,2,67,66,2,2,67,2,67,67,65          ; attrs

        defb 138,142,136,140,139,143,137,141,136,139,138,142,137,141,139,143
        defb 16,16,81,81,16,24,81,16,81,81,16,16,81,16,16,24    ; attrs

        defb 105,105,136,140,105,105,137,141,105,105,138,142,105,105,139,143
        defb 7,7,81,81,7,7,81,16,7,7,16,16,7,7,16,24            ; attrs

        defb 105,105,136,140,105,105,137,141,136,139,138,142,137,141,139,143
        defb 7,7,81,81,7,7,81,16,81,81,16,16,81,16,16,24        ; attrs

        defb 138,142,136,140,139,143,137,141,105,105,138,142,105,105,139,143
        defb 16,16,81,81,16,24,81,16,7,7,16,16,7,7,16,24        ; attrs

        defb 144,145,144,145,145,144,145,144,144,145,144,145,145,144,145,144
        defb 74,74,74,74,89,89,89,89,75,75,75,75,81,81,81,81    ; attrs

        defb 105,105,105,145,105,105,145,144,105,145,144,145,145,144,145,144
        defb 7,7,7,74,7,7,89,89,7,75,75,75,81,81,81,81          ; attrs

        defb 144,145,144,145,105,144,145,144,105,105,144,145,105,105,105,144
        defb 74,74,74,74,7,89,89,89,7,7,75,75,7,7,7,81          ; attrs

        defb 106,105,105,105,107,110,112,114,108,111,113,115,109,105,105,105
        defb 70,7,7,7,68,70,70,70,4,68,68,68,4,7,7,7            ; attrs

        defb 106,105,105,105,107,110,112,114,108,111,113,115,109,105,105,105
        defb 66,7,7,7,2,66,66,66,67,2,2,2,3,7,7,7               ; attrs

        defb 106,105,105,105,107,110,112,114,108,111,113,115,109,105,105,105
        defb 3,7,7,7,65,3,3,3,1,65,65,65,1,7,7,7                ; attrs

        defb 106,105,105,105,107,110,112,114,108,111,113,115,109,105,105,105
        defb 5,7,7,7,5,69,69,69,65,3,3,3,1,7,7,7                ; attrs

        defb 116,118,144,145,117,119,145,144,116,118,144,145,117,119,145,144
        defb 97,33,2,74,32,33,24,89,97,33,3,75,32,33,16,81      ; attrs

        defb 105,105,116,118,105,105,117,119,105,105,116,118,105,105,117,119
        defb 7,7,97,33,7,7,32,33,7,7,97,33,7,7,32,33            ; attrs

        defb 146,147,147,147,146,147,147,147,146,147,147,147,146,147,147,147
        defb 69,69,5,65,69,69,5,65,69,69,5,65,69,69,5,65        ; attrs

        defb 85,89,105,105,86,90,105,105,87,91,105,105,88,92,105,105
        defb 5,5,7,7,5,5,7,7,5,5,7,7,5,5,7,7                    ; attrs

        defb 105,105,85,89,105,105,86,90,105,105,87,91,105,105,88,92
        defb 7,7,5,5,7,7,5,5,7,7,5,5,7,7,5,5                    ; attrs

        defb 93,95,105,105,94,96,105,105,93,95,105,105,94,96,105,105
        defb 68,5,7,7,5,4,7,7,68,5,7,7,5,4,7,7                  ; attrs

        defb 105,105,93,95,105,105,94,96,105,105,93,95,105,105,94,96
        defb 7,7,68,5,7,7,5,4,7,7,68,5,7,7,5,4                  ; attrs

        defb 144,145,144,145,145,144,145,144,144,145,144,145,145,144,145,144
        defb 2,74,74,74,24,89,89,89,3,75,75,75,16,81,81,81      ; attrs

        defb 138,142,136,140,139,143,137,141,136,139,138,142,137,141,139,143
        defb 72,16,81,81,72,24,81,16,72,81,16,16,72,16,16,24    ; attrs

MAP equ 59592

UDGS equ 64360

END RUTINILLA